package Echiquier;

import Echiquier.Piece.*;

/**
 * La simulation de l'echiquier
 */
public class Echiquier {
    public static final int MAXLIG = 8; //nombre max de lignes
    public static final int MAXCOL = 8; //nombre max de colonnes
    Case[][] table;

    public Echiquier(){
        try {
            echiquierInit();
        }catch (EchiquierException e){}

    }

    //echiquer init
    private void echiquierInit() throws EchiquierException {
        table = new Case[MAXLIG][MAXCOL];

        ColorJoueur colorJoueur = null;
        Piece piece = null;

        for(int lig=0; lig<MAXLIG; lig++) {
            if(lig <= 1){
                colorJoueur = ColorJoueur.noir;
            }else {
                colorJoueur = ColorJoueur.blanche;
            }
            for (int col = 0; col < MAXCOL; col++) {
                table[lig][col] = new Case(lig,col);
                //ajouter les pieces dans l'echiquier
                if(lig <= 1 || lig >= 6) {
                    //ajouter les pions
                    if(lig == 1 || lig == 6){
                        piece = new Pion(table[lig][col], colorJoueur);
                    }
                    else {
                        //ajouter les tours
                        if(col == 0 || col == 7){
                            piece = new Tour(table[lig][col], colorJoueur);
                        }
                        //ajouter les cavaliers
                        if(col == 1 || col == 6){
                            piece = new Cavalier(table[lig][col], colorJoueur);
                        }
                        //ajouter les fous
                        if(col == 2 || col == 5){
                            piece = new Fou(table[lig][col], colorJoueur);
                        }
                        //ajouter les Dames
                        if(col == 3){
                            piece = new Dame(table[lig][col], colorJoueur);
                        }
                        //ajouter les rois
                        if(col == 4){
                            piece = new Roi(table[lig][col], colorJoueur);
                        }
                    }

                    piece.setEchiquier(this);

                    table[lig][col].setPiece(piece);
                }
            }
        }
        System.out.println("L'echiquier init");
    }

    public Case[][] getTable() {
        return table;
    }

    public static void main(String[] argv){
        new IHM(new Echiquier());
    }

    public Case getCase(int lig, int col){
        return table[lig][col];
    }

}
