package Echiquier;

import Echiquier.Piece.*;

import java.util.Scanner;

public class IHM {
    private Echiquier echiquier;
    private Case[][] table;
    public IHM(Echiquier echiquier){
        this.echiquier = echiquier;
        this.table = this.echiquier.getTable();
        echiquierInit();

        menu();
    }

    private void echiquierInit(){
        //afficher la numero de colonne
        for(int tmpcol=0; tmpcol < Echiquier.MAXCOL; tmpcol++) {
            System.out.print("  " + tmpcol);
        }
        System.out.println();

        //afficher la table de l'echiquier
        for(int lig=0; lig < Echiquier.MAXLIG; lig++){
            //afficher la separation de ligne
            System.out.print("  ");
            for(int tmplig=0; tmplig < Echiquier.MAXCOL; tmplig++) {
                System.out.print("---");
            }
            System.out.println();

            //afficher la numero de ligne
            System.out.print(lig);
            for(int col=0; col < Echiquier.MAXCOL; col++){
                //afficher la separation de colonne
                System.out.print("|");

                //afficher de la symbole de piece
                if(table[lig][col].estEuPiece()){
                    Piece piece = table[lig][col].getPiece();
                    if(piece.getClass() == Pion.class ){
                        System.out.print("P");
                    }
                    if(piece.getClass() == Cavalier.class){
                        System.out.print("C");
                    }
                    if(piece.getClass() == Dame.class){
                        System.out.print("D");
                    }
                    if(piece.getClass() == Fou.class){
                        System.out.print("F");
                    }
                    if(piece.getClass() == Roi.class){
                        System.out.print("R");
                    }
                    if(piece.getClass() == Tour.class){
                        System.out.print("T");
                    }

                    //affichier la color du joueur
                    if(piece.getColorJoueur() == ColorJoueur.noir){
                        System.out.print("N");
                    }
                    else {
                        System.out.print("B");
                    }
                }
                //afficher la vide case
                else{
                    System.out.print("  ");
                }
            }
            //afficher la dernier separation de colonne
            System.out.println("|");
        }
    }

    private void menu(){
        Case caseDepart = null;
        Case caseArrive = null;
        while(true){
            try {
                caseDepart = saisirString("Déplacement d'une pièce de (la position de case diviser par ':' ou ','): ");
                caseArrive = saisirString("vers(la position de case diviser par ':' ou ',') : ");
            } catch (Exception e){
                System.out.println(e);
            }
        }
    }

    private Case saisirString(String message){
        System.out.println(message);
        String valeur = "";
        try{
            Scanner sc = new Scanner(System.in);
            valeur = sc.nextLine();
        }catch(Exception e){
            System.out.println(e.getMessage());
            saisirString(message);
        }

        String[] divise = valeur.split("[:,]");
        if(divise.length != 2){
            System.out.println("La position drois est deux value(un ligne et un colone) qui divise par ':' ou ',' ");
            saisirString(message);
        }

        Case unCase = null;
        try {
            int col = Integer.parseInt(divise[1]);
            int lig = Integer.parseInt(divise[0]);

            System.out.println(lig);
            if(lig >= Echiquier.MAXLIG){
                System.out.println("La ligne droit inférieur à " + Echiquier.MAXLIG);
                saisirString(message);
            }

            if(col >= Echiquier.MAXCOL){
                System.out.println("La colonne droit inférieur à " + Echiquier.MAXCOL);
                saisirString(message);
            }

            unCase = new Case(lig, col);
        }catch (EchiquierException e){
            e.printStackTrace();
            saisirString(message);
        }

        return unCase;
    }
}
