package Echiquier.Piece;

import Echiquier.Case;
import Echiquier.ColorJoueur;
import Echiquier.EchiquierException;

public class Cavalier extends Piece {
    public Cavalier(Case unCase, ColorJoueur colorJoueur) {
        super(unCase, colorJoueur);
    }

    public void deplace(Case arrive) {
        if(estValide(arrive)){
            super.deplace(this,arrive);
        }else{
            deplaceInvalid(arrive);
        }
    }

    private boolean estValide(Case arrive){
        if(super.unCase.estEuPiece()){
            return false;
        }

        int ligDepart = super.getUnCase().getLig();
        int colDepart = super.getUnCase().getCol();

        int ligArrive = arrive.getLig();
        int colArrive = arrive.getCol();

        if( !(Math.abs(ligArrive - ligDepart) == 2 && Math.abs(colArrive - colDepart) == 1 ||
                Math.abs(ligArrive - ligDepart) == 1 && Math.abs(colArrive - colDepart) == 2)){
            return false;
        }

        if(arrive.getPiece().getColorJoueur() == super.getColorJoueur()){
            return false;
        }

        return true;
    }
}
